<?php

use App\Http\Controllers\BookingWorkbenchController;
use App\Http\Controllers\CalendarPriceController;
use App\Http\Controllers\FlightOfferPricingController;
use App\Http\Controllers\FlightOfferSearchController;
use App\Http\Controllers\AmaFlightOfferSearchController;
use App\Http\Controllers\AmaNDCController;
use App\Http\Controllers\TicketWorkbenchController;
use App\Http\Controllers\WorldpayPaymentController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "api" middleware group. Make something great!
|
*/

Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return $request->user();
});

//Amadeus API

Route::get("/ama", function () {
    return "Amadeus API working";
});

Route::post('/ama/search_offers', [AmaFlightOfferSearchController::class, "queryFareMasterPricer"]);
Route::post('/ama/combined_offers', [AmaFlightOfferSearchController::class, "queryCombinedOffers"]);
Route::post('/ama/combined_offers/paginate', [AmaFlightOfferSearchController::class, 'getOffersPage']);
Route::post('/ama/fare_informative_pricing_without_pnr', [AmaFlightOfferSearchController::class, "fareInformativePricingWithoutPNR"]);
Route::post('/ama/fare_check_rules', [AmaFlightOfferSearchController::class, "fareCheckRules"]);
Route::post('/ama/security_sign_out', [AmaFlightOfferSearchController::class, "securitySignOut"]);
Route::post('/ama/sel_from_recommendation', [AmaFlightOfferSearchController::class, "selRecommendation"]);
Route::post('/ama/add_pnr_multi_elements', [AmaFlightOfferSearchController::class, "addTravelerInPNRAddMultiElements"]);
Route::post('/ama/create_fop', [AmaFlightOfferSearchController::class, "createFOP"]);
Route::post('/ama/query_fare_price_pnr_with_booking_class', [AmaFlightOfferSearchController::class, "queryFarePricePNRWithBookingClass"]);
Route::post('/ama/create_tst_from_pricing', [AmaFlightOfferSearchController::class, "createTSTFromPricing"]);
Route::post('/ama/pnr_add_multi_elements_second', [AmaFlightOfferSearchController::class, "createPNRAddMultiElements"]);
Route::post('/ama/pnr_retrieve', [AmaFlightOfferSearchController::class, "queryPNRRetrieve"]);
Route::post('/ama/issue_ticket', [AmaFlightOfferSearchController::class, "issueTicket"]);

Route::post('/ama/payment_flow', [AmaFlightOfferSearchController::class, "paymentFlow"]);
Route::post('/ama/doc_issuance_flow', [AmaFlightOfferSearchController::class, "docIssuanceFlow"]);

Route::get('/ama/travelers', [AmaFlightOfferSearchController::class, "queryTravelers"]);

Route::post('/ama/ndc_travel_offer_price', [AmaNDCController::class, 'travelOfferPrice']);
Route::post('/ama/ndc_travel_order_create', [AmaNDCController::class, 'travelOrderCreate']);
Route::post('/ama/ndc_travel_order_pay', [AmaNDCController::class, 'travelOrderPay']);

Route::post('/worldpay/payment_order', [WorldpayPaymentController::class, 'processOrderForPayment']);

Route::get('/worldpay/success/{orderId}', [WorldpayPaymentController::class, 'success'])->name('payment.success');
Route::get('/worldpay/cancel', [WorldpayPaymentController::class, 'cancel'])->name('payment.cancel');
Route::get('/worldpay/failure/{orderId}', [WorldpayPaymentController::class, 'failure'])->name('payment.failure');
Route::get('/worldpay/error/{orderId}', [WorldpayPaymentController::class, 'error'])->name('payment.error');

Route::get('/test_uuid',[WorldpayPaymentController::class,'testUuid']);

